/**
 * @file moduninst.c
 *
 * @brief Driver deinstallation program.
 *
 * @author Georgievskiy Yury. CERN.
 *
 * @date May, 2005
 *
 * This program is automatically generated by the @b DriverGen.
 * Used to uninstall and exploit the drivers in the system.
 *
 * @version 2.0 ygeorgie 01/11/07 Unlimited module amount deinstallation
 *                                supported. Linux list is used.
 * @version 1.0 ygeorgie 14/04/05 Initial version
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#ifdef __linux__
#include <libgen.h> /* for basename */
#endif

#include "GeneralHeader.h"
#include "utils.h"

/* to suppress 'implicit declaration' warnings, and 'undefined vars' errors */
extern int bdv_uninstall(int);

/*======================Global data==========================================*/
char progName[DDNMSZ];		/* program name */

/* deinstall action */
typedef enum _tagDaction {	/* 'DO' action */
	DALL,		/* deinstall everything for the given module */
	DDRVR,		/* deinstall driver and all related devices */
	DSIM,		/* deinstall simulator and all related devices */
	DSAMPLE,	/* deinstall only specified devices */
	DQMOD,		/* only explore current module */
	DQDRVR,		/* only explore given driver */
	DERROR		/* error  */
} DACTION;

static int modDevLun[MAXMODNUM];	/*  module LUN's container */
static int mdla;		/* their actual amount */

static DACTION daction = DERROR;	/* error by default */
/*==================END of global data=======================================*/

static void  DisplayUsage();
static void  ParseProgArgs(int, char *[]);
static int   DeinstDrvr(void);
static int   DeinstSim();
static int   DeinstSample();
static void  ExcludeReplica();
static int   DriverAssassin(char *);
static char *BuildUpTitleLine();
static int   GetDim(int);
static int   GetTitleDim(int);
static int   MModule(char *);
static int   MDriver(char *, char *, int);
static int   MDevice(char *, char *, int);
static int   MNode(char *, char *);
static int   MNone(char *);
static void  QueryM();

int main(int argc, char *argv[], char *envp[])
{
	strncpy(progName, basename(argv[0]), sizeof(progName));
	printf("\n%s started...\n", progName);

	ParseProgArgs(argc, argv); /* check and set program arguments */

	switch (daction) {
	case DALL:
		printf("Complete module deinstallation requested.\n");
		if (DeinstDrvr() == -1)
			exit(EXIT_FAILURE);	/* 1 */
		if (DeinstSim() == -1)
			exit(EXIT_FAILURE);	/* 1 */
		printf("All done. Bye.\n");
		break;
	case DDRVR:
		printf("Driver deinstallation requested.\n");
		if (DeinstDrvr() == -1)
			exit(EXIT_FAILURE);	/* 1 */
		printf("All done. Bye.\n");
		break;
	case DSIM:
		printf("Simulator deinstallation requested.\n");
		if (DeinstSim() == -1)
			exit(EXIT_FAILURE);	/* 1 */
		printf("All done. Bye.\n");
		break;
	case DSAMPLE:
		/* check and correct, if necessary, provided LUN's
		   and their amount. Exclude replicant LUN's from the list. */
		ExcludeReplica();
		printf("Sample device deinstallation requested.\n");
		if (DeinstSample() == -1)
			exit(EXIT_FAILURE);	/* 1 */
		printf("All done. Bye.\n");
		break;
	case DQMOD:
		printf("Exploring %s module requested.\n",
		       db_mod_name(NULL, FALSE));
		QueryM();
		break;
	case DQDRVR:
		printf("Exploring %s driver requested.\n",
		       db_mod_name(NULL, FALSE));
		QueryM();
		break;
	case DERROR:
	default:
		exit(EXIT_FAILURE);	/* 1 */
		break;		/* not reached */
	}

	exit(EXIT_SUCCESS);	/* 0 */
}

/**
 * @brief Oooops... A daisy...
 */
static void DisplayUsage()
{
	printf("Usage:\n=> %s <module_name> -q<mod | drvr> -d<all | drvr"
	       " | sim> \\\n\t      -U<lun> ... -U<lun>\n\n", progName);
	printf(" Arguments are:\n");
	printf(" <module_name> %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Name of the module, for which either driver or simulator,"
	       " or specified\n    devices should be deinstalled. It should be"
	       " exactly as in the DataBase.\n    If <module_name> is not "
	       "provided, will try to get it from cwd,\n    by analyzing"
	       " *.info && *.ko files.\n    If some ambiguity encounts (i.e."
	       " several *.info files, several *.ko\n    for different module"
	       " types etc...), program will complain and stop.\n    In this"
	       " case you should help it and provide <module_name> "
	       "explicitly\n    in the command line.\n");
	printf(" -q %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Quering current module or particular driver configuration"
	       " and provide\n    it's graphical layout. Display all drivers,"
	       " devices and nodes for the\n    given module. Convinient way"
	       " to explore module or specified driver.\n    In this case '-d'"
	       " and '-U' are irrelevant.\n    Use '-qmod' option if you want"
	       " to see current module configuration.\n    You should provide"
	       " module name you are interesting in.\n    Use '-qdrvr' option"
	       " if you want to exploit particular driver.\n    In this case,"
	       " instead of providing module name you should designate exact\n"
	       "    drier name you are interested in. Like this - all"
	       " currently installed\n    drivers can be exploit.\n");
	printf(" -d %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Denotes, what should be deinstall. It's possible to"
	       " deinstall either\n    driver '-ddrvr', or simulator '-dsim',"
	       " or everything '-dall'.\n");
	printf(" -U %sOptional%s\n", WHITE_CLR, END_CLR);
	printf("    Denotes device Logical Unit Number (LUN), that user whants"
	       " to deinstall.\n    For simulators - LUN is negative. In this"
	       " case NOT Driver but Driver\n    Simulator devices will be"
	       " deinstalled from the kernel.\n\n");
	printf("    If user wants to deinstall all driver devices and driver"
	       " itself, then\n    '-ddrvr' option should provided.\n    If"
	       " user wants to deinstall all simulator devices and driver"
	       " simulator\n    itself, then he should provide '-dsim'"
	       " option.\n    If user wants to deinstall everything (i.e. all"
	       " devices, driver and\n    simulator), then '-dall' option"
	       " should be provided.\n    Note, that '-U' parameter is"
	       " irrelevant in this cases.\n\n    If some specific devices"
	       " should be deinstalled, than their Logical Unit\n    Numbers"
	       " (LUN's) should be provided. Remember, that for real devices"
	       " - LUN's\n    are positive, for simulated devices - negetive."
	       " Also note, that if there is\n    no more devices left, that"
	       " are using current module driver or driver\n    simulator - it"
	       " will be also deinstalled from the system.\n    Note, that"
	       " '-d' parameter is irrelevant in this case.\n\n");
	printf("  Examples:\n\t%s SHARED_CIBC -U10 -U-3 -U11 -U5\n\t%s"
	       " SHARED_CIBC -dall\n\t%s SHARED_CIBC -d drvr\n\t%s"
	       " SHARED_CIBC -qmod\n\t%s amd970 -qdrvr\n\n",
	       progName, progName, progName, progName, progName);
}

/**
 * @brief Parse command line arguments and fill in dev descr with raw data.
 *
 * @param argc -- command line argument count
 * @param argv -- command line argument array
 *
 * This data will be checked later by another function to see if it is correct.
 *
 * @return void
 */
static void ParseProgArgs(int argc, char *argv[])
{
	int cmdOpt;
	int argCntr = 0;	/* counter of non-option args */
	char mas[MAX_STR] = { 0 }; /* hold command options */
	uint dIsSet = FALSE, qIsSet = FALSE, uIsSet = FALSE;

	/* try to get default module name from cwd */
	set_def_mn(mas);

	/* Scan params of the command line */
	while ((cmdOpt = getopt(argc, argv, "-U:d:q:h")) != EOF) {
		switch (cmdOpt) {
#ifdef __Lynx__
		case 0:	/* this is non-option arg */
#else	/* __linux__ */
		case 1:
#endif
			if (argCntr == 1)
				break;
			strncpy(mas, optarg, MAX_STR);
			argCntr++;
			break;
		case 'h':	/* help information */
			DisplayUsage();
			exit(EXIT_SUCCESS);	/* 0 */
			break;
		case 'U':	/* Logical Unit Number */
			uIsSet = TRUE;
			daction = DSAMPLE;
			modDevLun[mdla] = atoi(optarg);
			if (mdla > MAXMODNUM) {
				fprintf(stderr,
					"Oooops... MAX module amount (%d),"
					" allowed to deinstall reached!\n"
					"Please contact '%s' support team.\n",
					MAXMODNUM, progName);
				exit(EXIT_FAILURE);
			}
			mdla++;
			break;
		case 'd':	/* what to deinstall */
			dIsSet = TRUE;
			if (!strcmp(optarg, "all"))
				daction = DALL;
			else if (!strcmp(optarg, "drvr"))
				daction = DDRVR;
			else if (!strcmp(optarg, "sim"))
				daction = DSIM;
			else {
				printf("Wrong '-d' option parameter.\n");
				exit(EXIT_FAILURE);	/* 1 */
			}
			break;
		case 'q':	/* module query */
			qIsSet = TRUE;
			if (!strcmp(optarg, "mod"))
				daction = DQMOD;
			else if (!strcmp(optarg, "drvr"))
				daction = DQDRVR;
			else {
				printf("Wrong '-q%s' argument.\n", optarg);
				exit(EXIT_FAILURE);	/* 1 */
			}
			break;
		case '?':	/* error */
			printf("Try \'%s -h\' for help.\n", progName);
			exit(EXIT_FAILURE);	/* 1 */
			break;
		default:
			break;
		}
	}

	if (!mas[0]) {	/* Module Name is expected */
		printf
		    ("Module Name is not provided.\nTry \'%s -h\' for help.\n",
		     progName);
		exit(EXIT_FAILURE);	/* 1 */
	}

	if (daction == DERROR) { /* neither '-d' nor '-U' option is provided */
		printf("Not enough command line arguments.\nTry \'%s -h\' "
		       "for help.\n", progName);
		exit(EXIT_FAILURE);	/* 1 */
	}

	if (qIsSet && (uIsSet || dIsSet)) {	/* ambiguous situation */
		printf("Ambiguous situation. '-query' can not be provided"
		       " with '-U' or '-d' options.\n");
		exit(EXIT_FAILURE);	/* 1 */
	}

	if (uIsSet && dIsSet) {	/* ambiguous situation */
		printf("Ambiguous situation. '-U' and '-d' options can not"
		       " be command line arguments at the same time.\n");
		exit(EXIT_FAILURE);	/* 1 */
	}

	/* set-up module name. exact as in the DataBase */
	if (db_mod_name(mas, (qIsSet) ? FALSE : TRUE) == (char *)-1)
		/* provided module name is wrong, barf */
		exit(EXIT_FAILURE);	/* 1 */
}


/**
 * @brief Deinstalling the driver from the system.
 *
 * @param void
 *
 * @return number of deinstall drivers.
 * @return -1 - in case of internal error. Error info is printed to the
 *              standard output.
 * @return -2 - drivers not found.
 */
static int DeinstDrvr(void)
{
	int retcode;

	int drAm = 0;		/* driver amount */
	char drvrNm[DDNMSZ];	/* driver name */

	printf("%s: Scanning for %s module drivers...    ", progName,
	       db_mod_name(NULL, FALSE));
	fflush(stdout);
	drAm = find_driver(build_drvr_nm(_DRVR_, drvrNm), NULL, 0);
	if (drAm == -1)
		return -1;
	else if (drAm)
		printf("Found %d %s driver.\n", drAm, drvrNm);
	else {
		printf("%s drivers not installed.\n", drvrNm);
		return -2;
	}

	printf("%s: Deinstalling driver(s)...\n", progName);
	retcode = DriverAssassin(drvrNm);
	if (retcode == -1)
		return -1;
	else if (retcode == -2)
		printf("%s: %s driver not installed.\n", progName, drvrNm);
	else if (!retcode)
		printf("%s: Driver deinstallation fails.\n", progName);
	else
		printf("%s: Driver deinstallation complete.\n", progName);

	return retcode;
}

/**
 * @brief Deinstallind driver simulator from the system.
 *
 * @param none
 *
 * @return number of deinstall simulators.
 * @return -1 - in case of internal error. Error info is printed to the
 *              standard output.
 * @return -2 - simulators not found.
 */
static int DeinstSim()
{
	int retcode = 0;

	int simAm = 0;		/* driver simulator amount */
	char simNm[DDNMSZ];	/* simulator name */

	printf("%s: Scanning for %s module simulators...    ", progName,
	       db_mod_name(NULL, FALSE));
	fflush(stdout);
	simAm = find_driver(build_drvr_nm(_SIML_, simNm), NULL, 0);
	if (simAm == -1)
		return -1;
	if (simAm)
		printf("Found %d %s simulator.\n", simAm, simNm);
	else {
		printf("%s simulators not installed.\n", simNm);
		return -2;
	}

	printf("%s: Deinstalling driver simulator(s)...\n", progName);
	retcode = DriverAssassin(simNm);
	if (retcode == -1)
		return -1;
	else if (retcode == -2)
		printf("%s: %s simulator not installed.\n", progName, simNm);
	else if (!retcode)
		printf("%s: Simulator deinstallation fails.\n", progName);
	else
		printf("%s: Simulator deinstallation complete.\n", progName);

	return retcode;
}

/**
 * @brief Deinstall specified devices, and their drivers, if they are
 *        not used anymore.
 *
 * @param none
 *
 * @return number of deinstall device samples.
 * @return -1 - in case of internal error. Error info is printed to the
 *              standard output.
 */
static int DeinstSample()
{
	int cntr, cntr1, cntr2;
	int res;

	int devAm;		/* found device amount */
	dev_desc devDescr[MAXMODNUM];	/* obtained device description */

	int nodeAm;		/* find node amount */
	char nodeNms[MAX_NODES][NODENMSZ];	/* node names */

	int retcode = 0;	/* deinstalled device amount */

	printf("%s: Scanning for %s module sample devices...\n", progName,
	       db_mod_name(NULL, FALSE));
	for (cntr = 0; cntr < mdla; cntr++) {
		BuildDevNm(modDevLun[cntr], devDescr[0].dev_name);

		/* get specific device */
		devAm = find_devices(-1, devDescr, sizeof(devDescr));

		if (devAm == -1)
			return devAm;	/* internal error */
		else if (!devAm) {
			printf("%s: %s sample not found.\n", progName,
			       devDescr[0].dev_name);
			continue;	/* no devices with this name */
		} else {
			printf("%s: %d %s device(s) found. Trying to"
			       " deinstall...\n",
			       progName, devAm, devDescr[0].dev_name);
			for (cntr1 = 0; cntr1 < devAm; cntr1++) {
				nodeAm = FindDevNodes(devDescr[cntr1].dev_id,
						      nodeNms, sizeof(nodeNms));
				/* remove all device node */
				for (cntr2 = 0; cntr2 < nodeAm; cntr2++) {
					if (unlink(nodeNms[cntr2]))
						printf("%s: %s[ %s] deleting %s"
						       " node failed.\n",
						       progName, ERR_MSG,
						       strerror(errno),
						       nodeNms[cntr2]);
					printf("%s: %s node removed.\n",
					       progName, nodeNms[cntr2]);
				}

				/* deinstall device */
				if (devDescr[cntr1].dev_type == CHAR_DEV)
					res = cdv_uninstall(devDescr[cntr1].
							    dev_id);
				else
					res = bdv_uninstall(devDescr[cntr1].
							    dev_id);

				if (res)
					printf("%s: %s[ %s] unload %s device"
					       " failed.\n",
					       progName, ERR_MSG,
					       strerror(errno),
					       devDescr[cntr1].dev_name);
				else {
					printf("%s: %s device unload.\n",
					       progName,
					       devDescr[cntr1].dev_name);
					retcode++;
				}
			}	/* end of 'else' */

			/* trying to deinstall device driver */
			res = dr_uninstall(devDescr[cntr].dev_drvrid);
			if (!res)
				printf("%s: %s driver unload from the"
				       " system.\n", progName,
				       build_drvr_nm((modDevLun[cntr] <0) ?
						     _SIML_ : _DRVR_, NULL));
		}
	} /* end of 'for' */

	return retcode;
}

/**
 * @brief Exclude replicant numbers from LUN's, that were provided by
 *        user in the command line.
 *
 * @return void
 */
static void ExcludeReplica()
{
	int replicamas[MAXMODNUM] = {[0 ... MAXMODNUM - 1] = 0xdeadbeef };
	int rcnt = 0;

	int finalmas[MAXMODNUM];
	int fcnt = 0;

	int cntr0 = 0, cntr1 = 1, cntr;
	int hit = 0;
	int rep = 0;

	for (cntr0 = 0; cntr0 < mdla; cntr0++) {
		hit = 0;
		rep = 0;

		for (cntr = 0; cntr < rcnt; cntr++)
			if (replicamas[cntr] == modDevLun[cntr0])
				rep++;
		if (rep)
			continue;

		for (cntr1 = cntr0 + 1; cntr1 < mdla; cntr1++) {
			rep = 0;

			for (cntr = 0; cntr < rcnt; cntr++)
				if (replicamas[cntr] == modDevLun[cntr1])
					rep++;
			if (rep)
				continue;

			if (modDevLun[cntr0] == modDevLun[cntr1])
				hit++;
		}

		if (hit)
			replicamas[rcnt++] = modDevLun[cntr0];

		finalmas[fcnt++] = modDevLun[cntr0];
	}

	memmove(modDevLun, finalmas, fcnt * sizeof(int));
	mdla = fcnt;
}

/**
 * @brief Removes module driver/simulator from the system completely,
 *        including all his devices and nodes.
 *
 * @param drvrNm - driver name
 *
 * @return number of uninstalled drivers - if success.
 * @return -1 - if case of any internal error. Error info is printed to
 *              the standard output.
 * @return -2 - if no such drivers found in the system.
 */
static int DriverAssassin(char *drvrNm)
{
	int res;
	int retres = 0;		/* deinstalled driver amount */
	int drAm = 0;		/* driver amount */
	driv_desc drdesc[MAXMODNUM];	/* driver description */

	int devAm;		/* found device amount */
	dev_desc devDescr[MAXMODNUM];	/* device description */

	int nodeAm;		/* find node amount */
	char nodeNms[MAX_NODES][NODENMSZ];	/* node names */

	int cntr0, cntr1, cntr2;	/* counters */

	drAm = find_driver(drvrNm, drdesc, sizeof(drdesc));

	if (drAm == -1)
		return drAm;
	if (!drAm)
		return -2;	/* no drivers found */

	/* pass through all drivers */
	for (cntr0 = 0; cntr0 < drAm; cntr0++) {
		/* get all driver devices */
		devAm = find_devices(drdesc[cntr0].driv_id, devDescr,
				     sizeof(devDescr));
		if (devAm == -1)
			return devAm;	/* internal error */
		else if (!devAm)
			continue;	/* no devices for this driver */
		else {		/* found some devices. Check them */
			for (cntr1 = 0; cntr1 < devAm; cntr1++) {
				nodeAm =
				    FindDevNodes(devDescr[cntr1].dev_id,
						 nodeNms, sizeof(nodeNms));
				/* remove all device node */
				for (cntr2 = 0; cntr2 < nodeAm; cntr2++) {
					if (unlink(nodeNms[cntr2]))
						printf
						    ("%s: %s[%s] deleting"
						     " %s node failed.\n",
						     progName, ERR_MSG,
						     strerror(errno),
						     nodeNms[cntr2]);
					printf("%s: %s node removed.\n",
					       progName, nodeNms[cntr2]);
				}

				/* deinstall device */
				if (devDescr[cntr1].dev_type == CHAR_DEV)
					res = cdv_uninstall(devDescr[cntr1].
							    dev_id);
				else
					res = bdv_uninstall(devDescr[cntr1].
							    dev_id);

				if (res)
					printf("%s: %s[%s] unload %s"
					       " device failed.\n",
					       progName, ERR_MSG,
					       strerror(errno),
					       devDescr[cntr1].dev_name);
				else
					printf("%s: %s device unload.\n",
					       progName,
					       devDescr[cntr1].dev_name);
			}
		}		/* end of 'else' */

		/* uninstall driver */
		res = dr_uninstall(drdesc[cntr0].driv_id);
		if (res)
			printf("%s: %s[%s] unload %s driver failed.\n",
			       progName, ERR_MSG, strerror(errno),
			       drdesc[cntr0].driv_name);
		else {
			printf("%s: %s driver unload from the system.\n",
			       progName, drdesc[cntr0].driv_name);
			retres++;
		}
	} /* all drivers are passed. end of 'for' */

	return retres;
}

#define printsym(sym, size, newl, with_plus)		\
do {							\
  int cntr;						\
  for (cntr = 0; cntr < size; cntr++)			\
    if ((with_plus) && ((!cntr) || (cntr == size-1)))	\
      printf("+");					\
    else						\
      printf(sym);					\
  if (newl)						\
    printf("\n");					\
} while (0)

#define createArrow(buf, sz)			\
do {						\
  char *ptr;					\
  ptr = buf;					\
  *ptr = '+'; ptr++;				\
  memset(ptr, '-', sz/2 - 1);			\
  ptr += sz/2 - 1;				\
  *ptr = '>'; ptr++;				\
  *ptr = 0;					\
} while (0)

#define DrawFirst()						\
do {								\
  printsym(" ", GetDim(1)/2, FALSE, FALSE);			\
  (total == globcntr + 1) ? putchar(' ') : putchar('|');	\
  printsym(" ", GetDim(1)/2, FALSE, FALSE);			\
} while (0)

#define DrawSecond()					\
do {							\
  printsym(" ", GetDim(2)/2, FALSE, FALSE);		\
  (devAm == cntr1 + 1) ? putchar(' ') : putchar('|');	\
  printsym(" ", GetDim(2)/2, FALSE, FALSE);		\
} while (0)

#define DrawThird()					\
do {							\
  printsym(" ", GetDim(3)/2, FALSE, FALSE);		\
  (nodeAm == cntr2 + 1) ? putchar(' ') : putchar('|');	\
  printsym(" ", GetDim(3)/2, FALSE, FALSE);		\
} while (0)

#define DrawFirstRectangle()			\
do {						\
  printsym(" ",  GetDim(1)/2, FALSE, FALSE);	\
  printf("|");					\
  printsym(" ", GetDim(1)/2, FALSE, FALSE);	\
} while(0)

#define DrawSecondRectangle()				\
do {							\
  DrawFirst();						\
  printsym(" ",  GetDim(2)/2, FALSE, FALSE);		\
  printf("|");						\
  printsym(" ", GetDim(2)/2, FALSE, FALSE);		\
} while(0)

#define DrawThirdRectangle()				\
do {							\
  DrawFirst();						\
  DrawSecond();						\
  printsym(" ",  GetDim(3)/2, FALSE, FALSE);		\
  printf("|\n");					\
} while(0)

/**
 * @brief
 *
 * @param
 *
 * @return build-up line.
 */
static char *BuildUpTitleLine()
{
	static char titleStr[2048];
	char *ptr = titleStr;
	int dim1, dim2, dim3, dim4;

	memset(titleStr, ' ', sizeof(titleStr));

	dim1 = (GetDim(1) > GetTitleDim(1)) ? GetDim(1) : GetTitleDim(1);
	dim2 = (GetDim(2) > GetTitleDim(2)) ? GetDim(2) : GetTitleDim(2);
	dim3 = (GetDim(3) > GetTitleDim(3)) ? GetDim(3) : GetTitleDim(3);
	dim4 = (GetDim(4) > GetTitleDim(4)) ? GetDim(4) : GetTitleDim(4);

	ptr += (dim1) / 2 - 3;
	memcpy(ptr, "MODULE", strlen("MODULE"));
	ptr = titleStr;
	ptr += dim1 - 1;
	*ptr = '|';
	ptr++;

	ptr += (dim2) / 2 - 3;
	memcpy(ptr, "DRIVER(S)", strlen("DRIVER(S)"));
	ptr = titleStr;
	ptr += dim1 + dim2 - 1;
	*ptr = '|';
	ptr++;

	ptr += (dim3) / 2 - 3;
	memcpy(ptr, "DEVICE(S)", strlen("DEVICE(S)"));
	ptr = titleStr;
	ptr += dim1 + dim2 + dim3 - 1;
	*ptr = '|';
	ptr++;

	ptr += (dim4) / 2 - 2;
	memcpy(ptr, "NODE(S)", strlen("NODE(S)"));
	ptr = titleStr;
	ptr += dim1 + dim2 + dim3 + dim4 - 1;
	*ptr = '\n';
	ptr++;

	memset(ptr, '-', dim1);
	ptr += dim1 - 1;
	*ptr = '+';
	ptr++;

	memset(ptr, '-', dim2);
	ptr += dim2 - 1;
	*ptr = '+';
	ptr++;

	memset(ptr, '-', dim3);
	ptr += dim3 - 1;
	*ptr = '+';
	ptr++;

	memset(ptr, '-', dim4);
	ptr += dim4 - 1;
	*ptr = '\n';
	ptr++;

	ptr += dim1 - 1;
	*ptr = '|';
	ptr++;

	ptr += dim2 - 1;
	*ptr = '|';
	ptr++;

	ptr += dim3 - 1;
	*ptr = '|';
	ptr++;

	*ptr = 0;
	return titleStr;
}

/**
 * @brief Get dimensions.
 *
 * @param sz - 1 - module, 2 - driver, 3 - device, 4 - node, 5 - none
 *
 * @return max middle line sizes, based on the @b sz parameter.
 */
static int GetDim(int sz)
{
	static int szModule = 0; /* module name strlen */
	static int szDriver = 0; /* driver name strlen */
	static int szDevice = 0; /* device name strlen */
	static int szNode = 0;	 /* node name strlen */
	static int szNone = 0;	 /* none name strlen */

	char modNm[DDNMSZ + 32];	/* module name */
	char drvrNm[DDNMSZ + 32];	/* driver name */
	char devNm[DDNMSZ + 32];	/* device name */
	char nodeNm[DDNMSZ + 32];	/* node name */
	char noneNm[DDNMSZ];	/* none name */

	int ret = -1;

	if (!szModule && !szDriver && !szDevice && !szNode && !szNone) {
		snprintf(modNm, sizeof(modNm), "| %s |",
			 db_mod_name(NULL, FALSE));
		snprintf(drvrNm, sizeof(drvrNm), "| %s Id#%-3d |",
			 build_drvr_nm(_DRVR_, NULL), 0);
		snprintf(devNm, sizeof(devNm), "| %s Id#%-3d |",
			 BuildDevNm(MAXMODNUM, NULL), 0);
		snprintf(nodeNm, sizeof(nodeNm), " %s",
			 BuildNodeNm(MAXMODNUM, MAX_NODES, NULL));
		snprintf(noneNm, sizeof(noneNm), " %s", "NONE");

		szModule = strlen(modNm);
		szDriver = strlen(drvrNm);
		szDevice = strlen(devNm);
		szNode = strlen(nodeNm);
		szNone = strlen(noneNm);
	}

	switch (sz) {
	case 1:
		ret = szModule;
		break;
	case 2:
		ret = szDriver;
		break;
	case 3:
		ret = szDevice;
		break;
	case 4:
		ret = szNode;
		break;
	case 5:
		ret = szNone;
		break;
	default:
		ret = -1;
		break;
	}

	return ret;
}

/**
 * @brief
 *
 * @param sz -  1 - module, 2 - driver, 3 - device, 4 - node
 *
 * @return min title line lengthes, based on the @b sz parameter.
 */
static int GetTitleDim(int sz)
{
	int ret = -1;

	switch (sz) {
	case 1:
		ret = strlen(" MODULE |");
		break;
	case 2:
		ret = strlen(" DRIVER(S) |");
		break;
	case 3:
		ret = strlen(" DEVICE(S) |");
		break;
	case 4:
		ret = strlen(" NODE(S) ");
		break;
	default:
		ret = -1;
		break;
	}

	return ret;
}

/**
 * @brief Build-up module middle line.
 *
 * @param ptr - build-up line will be put here
 *
 * @return module middle line strlen.
 */
static int MModule(char *ptr)
{
	sprintf(ptr, "| %s |", db_mod_name(NULL, FALSE));
	return strlen(ptr);
}

/**
 * @brief Build-up driver middle line.
 *
 * @param ptr   - build-up line will be put here
 * @param drvrn - exact driver name
 * @param id    - driver id
 *
 * @return driver middle line strlen.
 */
static int MDriver(char *ptr, char *drvrn, int id)
{
	sprintf(ptr, "| %s Id#%-3d |", drvrn, id);
	return strlen(ptr);
}

/**
 * @brief Build-up device middle line.
 *
 * @param ptr   - build-up line will be put here
 * @param devNm - device name
 * @param id    - device id
 *
 * @return device middle line strlen.
 */
static int MDevice(char *ptr, char *devNm, int id)
{
	int lun = GetDevLunFromName(devNm);

	if (lun == NO_LUN)	/* can't get device LUN */
		sprintf(ptr, "| %s Id#%-3d |", devNm, id);
	else
		sprintf(ptr, "| %s Id#%-3d LUN#%-2d |", devNm, id, lun);

	return strlen(ptr);
}

/**
 * @brief Build-up node middle line.
 *
 * @param ptr    - build-up line will be put here
 * @param nodeNm - node name
 *
 * @return node middle line strlen.
 */
static int MNode(char *ptr, char *nodeNm)
{
	sprintf(ptr, " %s", nodeNm);
	return strlen(ptr);
}

/**
 * @brief Build-up NONE middle line.
 *
 * @param ptr - build-up line will be put here
 *
 * @return line strlen.
 */
static int MNone(char *ptr)
{
	sprintf(ptr, " %s", "NONE");
	return strlen(ptr);
}

/**
 * @brief Exploit and figure out all drivers, devices and nodes of the
 *        current module.
 *
 * @param none
 *
 * @return void
 */
static void QueryM()
{
	int cntr = 0, cntr1 = 0, cntr2 = 0;	/* counters */

	/* for drivers */
	int total = 0;	/* total amount of find drivers and simulators */
	int drvrAm, simAm;	/* found driver and simulator amount */
	driv_desc drdesc[MAXMODNUM];	/* real driver description */
	driv_desc simdesc[MAXMODNUM];	/* driver simulator description */

	/* for devices */
	int devAm;		/* found device amount */
	dev_desc devDescr[MAXMODNUM];	/* device description */

	/* for nodes */
	int nodeAm;		/* found node amount */
	char nodeNms[MAX_NODES][NODENMSZ];	/* node names */

	char dsName[2][DDNMSZ] = {[0] {0},[1] {0} };	/* [0] simulator name
							   [1] driver name */

	char firstArrow[48], secondArrow[48], thirdArrow[48];

	int globAmPtr, drvrcntr, globcntr = 0;
	driv_desc *globddPtr;
	char *globNm;

	/* will hold build-up middle lines */
	char strModNm[48], strDrvrNm[48], strDevNm[48], strNodeNm[48];
	int szA;

	if (daction == DQDRVR)
		strncpy(dsName[1], db_mod_name(NULL, FALSE), DDNMSZ);
	else {
		build_drvr_nm(_SIML_, dsName[0]);
		build_drvr_nm(_DRVR_, dsName[1]);
	}

	/* find drivers */
	if ((drvrAm = find_driver(dsName[1], drdesc, sizeof(drdesc))) < 0)
		exit(EXIT_FAILURE);

	/* find simulators */
	if ((simAm = find_driver(dsName[0], simdesc, sizeof(simdesc))) < 0)
		exit(EXIT_FAILURE);

	printf("\n");

	if (drvrAm == 0)
		printf("%s driver is not installed in the system.\n",
		       dsName[1]);
	else
		printf("%d %s driver(s) found.\n", drvrAm, dsName[1]);

	if (daction == DQMOD) {
		if (simAm == 0)
			printf("%s simulator is not installed in the system.\n",
			       dsName[0]);
		else
			printf("%d %s simulator(s) found.\n", simAm, dsName[0]);
	}

	if (!drvrAm && !simAm)
		exit(EXIT_SUCCESS);

	printf("\n");

	printf("%s\n", BuildUpTitleLine());

	total = drvrAm + simAm;

	szA = MModule(strModNm);

	printsym("-", szA, TRUE, TRUE);
	printf("%s\n", strModNm);
	printsym("-", szA, TRUE, TRUE);

	createArrow(firstArrow, GetDim(1));
	createArrow(secondArrow, GetDim(2));
	createArrow(thirdArrow, GetDim(3));

	/* ==========pass through all drivers and simulators================ */
	for (drvrcntr = 0; drvrcntr < 2; drvrcntr++) {

		switch (drvrcntr) {
		case 0:
			globddPtr = simdesc;
			globAmPtr = simAm;
			globNm = _SIML_;
			break;
		case 1:
			globddPtr = drdesc;
			globAmPtr = drvrAm;
			globNm = _DRVR_;
			break;
		}
		/* check all driver/simulator descriptions */
		for (cntr = 0; cntr < globAmPtr; cntr++, globcntr++) {
			int cursz =
			    MDriver(strDrvrNm,
				    (daction == DQDRVR) ? dsName[1] :
				    globddPtr[cntr].driv_name,
				    globddPtr[cntr].driv_id);

			/* entrance */
			DrawFirstRectangle();

			/* upper line */
			printsym("-", cursz, TRUE, TRUE);

			/* middle line */
			printsym(" ", GetDim(1) / 2, FALSE, FALSE);
			printf("%s%s\n", firstArrow, strDrvrNm);

			/* under line */
			DrawFirst();
			printsym("-", cursz, TRUE, TRUE);

			/* DEVICE EXPLOIT */
			/* get all driver devices */
			if ((devAm = find_devices(globddPtr[cntr].driv_id,
						  devDescr,
						  sizeof(devDescr))) < 0)
				exit(EXIT_FAILURE);

			/* reset counter */
			cntr1 = 0;

			if (!devAm) {	/* no devices for this driver */
				MNone(strDevNm);
				devAm++;

				/* draw downline */
				DrawSecondRectangle();

				/* middle line */
				printf("\n");
				DrawFirst();
				printsym(" ", GetDim(2) / 2, FALSE, FALSE);
				printf("%s%s\n", secondArrow, strDevNm);
				continue;
			}

			/* ==============pass through all devices============ */
			for (cntr1 = 0; cntr1 < devAm; cntr1++) {
				int csz2 =
				    MDevice(strDevNm, devDescr[cntr1].dev_name,
					    devDescr[cntr1].dev_id);

				/* draw downline */
				DrawSecondRectangle();

				/* upper line */
				printsym("-", csz2, TRUE, TRUE);

				/* middle line */
				DrawFirst();
				printsym(" ", GetDim(2) / 2, FALSE, FALSE);
				printf("%s%s\n", secondArrow, strDevNm);

				/* under line */
				DrawFirst();
				DrawSecond();
				printsym("-", csz2, TRUE, TRUE);

				/* NODE EXPLOIT */
				nodeAm =
				    FindDevNodes(devDescr[cntr1].dev_id,
						 nodeNms, sizeof(nodeNms));

				/* draw downline */
				DrawThirdRectangle();

				/* reset counter */
				cntr2 = 0;

				if (!nodeAm) {	/* no nodes for this device */
					MNone(strNodeNm);
					nodeAm++;

					/* middle line */
					DrawFirst();
					DrawSecond();
					printsym(" ", GetDim(3) / 2, FALSE,
						 FALSE);
					printf("%s%s\n", thirdArrow, strNodeNm);
					continue;
				}

				/* ============pass through all nodes======== */
				for (cntr2 = 0; cntr2 < nodeAm; cntr2++) {
					MNode(strNodeNm,
					      basename(nodeNms[cntr2]));

					/* middle line */
					DrawFirst();
					DrawSecond();
					printsym(" ", GetDim(3) / 2, FALSE,
						 FALSE);
					printf("%s%s\n", thirdArrow, strNodeNm);
				}
			}
		}
	}

	printf("\n");

	exit(EXIT_SUCCESS);
}
